package uniandes.teolen.automatas.mundoAutomata;

import java.util.*;

public class ACGT2 extends Automata {

	private Hashtable<State,State []>   deltaTable;
	
	public ACGT2()
	{
	
		super();
	
		States myStates = new States() ;
		
		ArrayList <State> myFinalStates = new ArrayList <State> ();
		
		State myStartState;
		
		myStates.storeState(s("inic"));
		myStates.storeState(s("a"));
		myStates.storeState(s("c"));
		myStates.storeState(s("t"));
		myStates.storeState(s("g"));
		myStates.storeState(s("fin"));
		myStates.storeState(s("err"));
		
		myFinalStates.add(s("err"));
		myStartState = s("inic");
	
		 
		deltaTable = new Hashtable<State, State []>();
		                                        //  a, c, g, t, $
		deltaTable.put(s("inic"), new State [] {s("a"), s("c"), s("err"), s("t"), s("fin")} );
		deltaTable.put(s("a"),    new State [] {s("a"), s("c"), s("g"), s("t"), s("fin")} );
		deltaTable.put(s("c"),    new State [] {s("a"), s("c"), s("err"), s("t"), s("fin")} );
		deltaTable.put(s("g"),    new State [] {s("a"), s("err"), s("g"), s("t"), s("err")} );
		deltaTable.put(s("t"),    new State [] {s("a"), s("c"), s("g"), s("t"), s("fin")} );
		deltaTable.put(s("fin"), new State [] {s("err"), s("err"), s("err"), s("err"), s("err")} );
		deltaTable.put(s("err"), new State [] {s("err"), s("err"), s("err"), s("err"), s("err")} );
						
		initializeAutomata(myStates,myStartState,myFinalStates);
	}	
	
	private int  charCode (char c) throws Exception {
		if (c=='a')
			return 0;
		else if (c == 'c')
			return 1;
		else if (c == 'g')
			return 2;
		else if (c == 't')
			return 3;
		else if (c == '$')
			return 4;
		else {
			throw new Exception ( "Caracter indefinido para automata: "+c );
		}
			
		
		
	}
	protected State delta(State s, char c) throws Exception {
		
		return (deltaTable.get(s))[charCode(c)];
	}

	 public String toString() {
		   return "ACGT2";
	   }
}
