package uniandes.teolen.automatas.mundoAutomata;

import java.util.ArrayList;

public class ContadorModuloN extends Automata{
	private int n;
	
	public ContadorModuloN(int  n)
	{ 
		super();
		this.n = n;
		States myStates = new States() ;
		
		ArrayList <State> myFinalStates = new ArrayList <State> ();
		
		State myStartState;
		
		int i;
		for (i=0; i<n; i++){
			myStates.storeState(s(i));
		}
		myFinalStates.add(s(0));
		myStartState = s(0);
		initializeAutomata(myStates,myStartState,myFinalStates);
	}	
	
	protected State delta(State st, char c) throws Exception{
		
		State resp;
		int stVal = (Integer) st.id();
		
		if (c == 'a') { 
			resp =  s((stVal+1)%n);
		}
		else if (c == 'b'){
			resp = st;
		}
		else 
			throw new Exception("Error: caracter no permitido - "+c);
		
		return resp;
      }
	
	
	
	public String toString() {
		   return "Contador Modulo "+n;
	   }
}
