package uniandes.teolen.automatas.mundoAutomata;

import java.util.*;

public class Petri2 extends Automata {

	private Hashtable<State,State []>   deltaTable;
	
	public Petri2()
	{
	
		super();
	
		States myStates = new States() ;
		
		System.out.println("Petri2");
		ArrayList <State> myFinalStates = new ArrayList <State> ();
		
		State myStartState;
		
		myStates.storeState(s(0,0));
		myStates.storeState(s(0,1));
		myStates.storeState(s(1,0));
		myStates.storeState(s(1,1));
		
		myStartState = s(0,0);
	
		 
		deltaTable = new Hashtable<State, State []>();
		
		deltaTable.put(s(0,0), new State [] {s(0,0),s(0,1)} );
		deltaTable.put(s(0,1), new State [] {s(1,1),s(0,1)} );
		deltaTable.put(s(1,0), new State [] {s(1,0),s(1,1)} );
		deltaTable.put(s(1,1), new State [] {s(1,1),s(1,1)} );
				
		initializeAutomata(myStates,myStartState,myFinalStates);
	}	
	
	private int  charCode (char c) throws Exception {
		if (c=='a')
			return 0;
		else if (c=='b')
			return 1;
		else {
			throw new Exception ( "Caracter indefinido para automata: "+c );
		}
	}

	protected State delta(State s, char c) throws Exception {
		System.out.println(s);
		
		return (deltaTable.get(s))[charCode(c)];
	}

	 public String toString() {
		   return "Petri2";
	   }

	  protected  String stateOutput(State s) {
		   return s.toString();
	   }
	   
}
