package uniandes.teolen.automatas.TestAutomata;

import java.io.*;

import uniandes.teolen.automatas.mundoAutomata.*;


public class Test {
	
	private static Automata  autos [] = {new VerificadorParidad(),new ContadorModuloN(3), new FraseAceptable(), new HasCat(), new Taller2(), new ContadorModuloN(5), new DivisionN_Base10(4), new DivisionN_BaseB(7,16), };
	
	public static void main(String args[]) throws IOException {
		
		Automata auto = autos[0];
		
		
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	    String s;
	    
	    System.out.println("choose 1 for parity, 2 for mod 3, 3 for fraseAceptable, 4 for hasCat, 5 for last, 6 for mod 5, 7 for div 4, 8 for div 7 in base 16 -->");
	    while ((s = in.readLine()) != null && s.length() != 0) {
	      int option=s.matches("[0-9]+")?Integer.parseInt(s):-1;
	    	if (option<1 || option>autos.length) 
	    	{	
	    		System.out.println("opcin no vlida");
	    	}
	    	else {
	    		auto = autos[option-1];
	    		System.out.println("input -->");
	    		while ((s = in.readLine()) != null && s.length() != 0) {
	    			System.out.println(s);
	    			auto.setInput(s);
	    			try {
	    				if (auto.processString())
	    					System.out.println("       aceptada!!");
	    				else
	    					System.out.println("      no aceptada!!");
	    			
	    				System.out.println(auto.getOutput());
	    			}
	    			catch (Exception error) {
	    			  error.printStackTrace();
	    				System.out.println("ERROR:  "+ error.getMessage());
	    			}
	    				
	    			System.out.println("input -->");
	    			}
	    	  }	
	    		System.out.println("choose 1 for parity, 2 for mod 3, 3 for fraseAceptable, 4 for hasCat, 5 for last, 6 for mod 5, 7 for div 4, 8 for div 7 in base 16 -->");
	    	  }
	    System.out.println("BYE");

	}
	
}