
package uniandes.teolen.automatas.interfaseProbador;

import javax.swing.*;

import java.awt.Component;
import java.awt.event.*;


/**
* InputCellListener
*  Action Listener for a text cell where <RTN> causes the component to loose focus and pass it
*  on to the next focusable component
*/


class InputCellListener implements ActionListener {		
	   static final public InputCellListener myCellListener = new InputCellListener(); 
		
		private InputCellListener (){
			super();
		}
		
		public void actionPerformed(ActionEvent ev) {
		Component nextFocusableComponent = ((JComponent) ev.getSource()).getNextFocusableComponent();
		try {			
				nextFocusableComponent.requestFocus();
		}
		catch (Exception e) {
			System.out.println(e);
			System.out.println(nextFocusableComponent);	
		
		}
		}
	
	
		public static InputCellListener getInstance() {
			return myCellListener;	
		}
		
}

