package uniandes.teolen.automatas.interfaseProbador;

import java.awt.event.*;
import javax.swing.*;
import java.awt.*;




class OneIntegerDialog  extends JDialog {
	
		private JLabel  field;
		
		private JTextField  stringInput;
		
		private int input;
		
		private JButton bOK;
		private JButton bCancel;
		
		private boolean ok;
		
	
		OneIntegerDialog(String dName, String name, int input) {
		
			super();
	
	 		setModal(true);
			setTitle(dName);
			ok = false;
			field = new JLabel(name);
			stringInput = new JTextField(Integer.toString(input));
			bOK = new JButton("OK");
			bCancel = new JButton("Cancel");
			getContentPane().setLayout(new GridLayout(2,2));
			getContentPane().add(field);
			getContentPane().add(stringInput);
			getContentPane().add(bOK);
			getContentPane().add(bCancel);			
						
			pack();	
			bCancel.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					ok = false;
					setVisible(false);
				}
			});
		
			bOK.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						setInput((new Integer(stringInput.getText())).intValue());
				        ok = true;
				        setVisible(false);
						
					}
					catch (Exception ex){
						stringInput.setText("");	
					}	
					}
			});
		
			//stringInput.addActionListener(new InputCellListener());
			
			stringInput.addActionListener(InputCellListener.myCellListener);	
			stringInput.setNextFocusableComponent(bOK);
			stringInput.addFocusListener(IntegerCellFocusListener.intFocus);
		}	
	
		
		boolean hasInput() {
			return ok;
		}	
	
		public int getInput() {
			return input;
		}
		
		private void setInput(int x) {
			input = x;	
		}
	}		
		
