package uniandes.teolen.automatas.mundoAutomata;

import java.util.ArrayList;

public class VerificadorParidad extends Automata {

	public VerificadorParidad()
	{
	
		super();
		States myStates = new States() ;
		
		ArrayList <State> myFinalStates = new ArrayList <State> ();
		
		State myStartState;
		
		int i;
		for (i=0; i< 8; i++){
			myStates.storeState(s(i,0));
			myStates.storeState(s(i,1));	
		}
		myFinalStates.add(s(0,0));
		myStartState = s(0,0);
		initializeAutomata(myStates,myStartState,myFinalStates);
	}	
		
	protected State delta(State s, char c) throws Exception{
		
		
		State resp;
		int   cval = c - '0';
		
		if (cval < 0  || cval > 1)
			throw new Exception("Error: caracter no permitido - "+c);
		
		if (s.equals(s(0,1))) { // este es el estado de error del cual no puede salir
			resp = s;
		}
		else if ( ((Integer)s.nTh(0))== 7)  {
			if (cval == (Integer) s.nTh(1))
				resp =  s(0,0);
			else 
				resp = s(0,1);
		}
		else  {
			resp = s((Integer)s.nTh(0)+1, ((Integer)s.nTh(1) + cval) % 2);
		}
		return resp;
	}
	
	 public String toString() {
		   return "Verificador Paridad ";
	   }
	
    }


